﻿; Generate Stabilizer MMX
; Copyright (c) 2017-2019, Hiroyuki Yokota (oryaaaaa)
Global NewList SourceList.s()

Macro Out
  AddElement(SourceList()) : SourceList() = 
EndMacro

Macro FNOPx32
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
  Out "FNOP"
EndMacro

Macro INIT_MMX
  For I = 0 To 7
    Out "PXOR mm"+Str(I)+", mm"+Str(I)
    Out "PXOR mm"+Str(I)+", mm"+Str(I)
    Out "PAND mm"+Str(I)+", mm"+Str(I)
    Out "PAND mm"+Str(I)+", mm"+Str(I)
    Out "PXOR mm"+Str(I)+", mm"+Str(I)
    Out "PXOR mm"+Str(I)+", mm"+Str(I)
    Out "PAND mm"+Str(I)+", mm"+Str(I)
    Out "PAND mm"+Str(I)+", mm"+Str(I)
  Next
  For I = 0 To 7
    If Not I=5
      Out "MOVQ mm"+Str(I)+", mm5"
    EndIf
  Next
EndMacro

Macro Isolate_MMX
  ; MOVQ mm3, Rax
  Out "MOVQ mm1, mm3"
  Out "MOVQ mm7, mm1"
  Out "MOVQ mm2, mm7"
  Out "MOVQ mm6, mm2"
  Out "MOVQ mm4, mm6"
  Out "MOVQ mm5, mm4"
  ; MOVQ Rax, mm5
EndMacro

INIT_MMX
Out "MOVQ mm3, Rdi"
Out "XOR Rdi, Rdi"
Out "XOR Rdi, Rdi"
Out "AND Rdi, Rdi"
Out "AND Rdi, Rdi"
Out "MOVQ Rdi, mm5"
Isolate_MMX
Out "MOVQ Rdi, mm5"
  
INIT_MMX
Out "MOVQ mm3, Rbp"
Out "XOR Rbp, Rbp"
Out "XOR Rbp, Rbp"
Out "AND Rbp, Rbp"
Out "AND Rbp, Rbp"
Out "MOVQ Rbp, mm5"
Isolate_MMX
Out "MOVQ Rbp, mm5"
  
INIT_MMX
Out "MOVQ mm3, Rbx"
Out "XOR Rbx, Rbx"
Out "XOR Rbx, Rbx"
Out "AND Rbx, Rbx"
Out "AND Rbx, Rbx"
Out "MOVQ Rbx, mm5"
Isolate_MMX
Out "MOVQ Rbx, mm5"
  
INIT_MMX
Out "MOVQ mm3, Rcx"
Out "XOR Rcx, Rcx"
Out "XOR Rcx, Rcx"
Out "AND Rcx, Rcx"
Out "AND Rcx, Rcx"
Out "MOVQ Rcx, mm5"
Isolate_MMX
Out "MOVQ Rcx, mm5"
  
INIT_MMX
Out "MOVQ mm3, R8"
Out "XOR R8, R8"
Out "XOR R8, R8"
Out "AND R8, R8"
Out "AND R8, R8"
Out "MOVQ R8, mm5"
Isolate_MMX
Out "MOVQ R8, mm5"
  
INIT_MMX
Out "MOVQ mm3, R10"
Out "XOR R10, R10"
Out "XOR R10, R10"
Out "AND R10, R10"
Out "AND R10, R10"
Out "MOVQ R10, mm5"
Isolate_MMX
Out "MOVQ R10, mm5"

INIT_MMX
Out "MOVQ mm3, R12"
Out "XOR R12, R12"
Out "XOR R12, R12"
Out "AND R12, R12"
Out "AND R12, R12"
Out "MOVQ R12, mm5"
Isolate_MMX
Out "MOVQ R12, mm5"
  
INIT_MMX
Out "MOVQ mm3, R14"
Out "XOR R14, R14"
Out "XOR R14, R14"
Out "AND R14, R14"
Out "AND R14, R14"
Out "MOVQ R14, mm5"
Isolate_MMX
Out "MOVQ R14, mm5"
  
INIT_MMX
Out "MOVQ mm3, Rsi"
Out "XOR Rsi, Rsi"
Out "XOR Rsi, Rsi"
Out "AND Rsi, Rsi"
Out "AND Rsi, Rsi"
Out "MOVQ Rsi, mm5"
Isolate_MMX
Out "MOVQ Rsi, mm5"

INIT_MMX
Out "MOVQ mm3, Rsp"
Out "XOR Rsp, Rsp"
Out "XOR Rsp, Rsp"
Out "AND Rsp, Rsp"
Out "AND Rsp, Rsp"
Out "MOVQ Rsp, mm5"
Isolate_MMX
Out "MOVQ Rsp, mm5"

INIT_MMX
Out "MOVQ mm3, Rax"
Out "XOR Rax, Rax"
Out "XOR Rax, Rax"
Out "AND Rax, Rax"
Out "AND Rax, Rax"
Out "MOVQ Rax, mm5"
Isolate_MMX
Out "MOVQ Rax, mm5"

INIT_MMX
Out "MOVQ mm3, Rdx"
Out "XOR Rdx, Rdx"
Out "XOR Rdx, Rdx"
Out "AND Rdx, Rdx"
Out "AND Rdx, Rdx"
Out "MOVQ Rdx, mm5"
Isolate_MMX
Out "MOVQ Rdx, mm5"

INIT_MMX
Out "MOVQ mm3, R9"
Out "XOR R9, R9"
Out "XOR R9, R9"
Out "AND R9, R9"
Out "AND R9, R9"
Out "MOVQ R9, mm5"
Isolate_MMX
Out "MOVQ R9, mm5"

INIT_MMX
Out "MOVQ mm3, R11"
Out "XOR R11, R11"
Out "XOR R11, R11"
Out "AND R11, R11"
Out "AND R11, R11"
Out "MOVQ R11, mm5"
Isolate_MMX
Out "MOVQ R11, mm5"

INIT_MMX
Out "MOVQ mm3, R13"
Out "XOR R13, R13"
Out "XOR R13, R13"
Out "AND R13, R13"
Out "AND R13, R13"
Out "MOVQ R13, mm5"
Isolate_MMX
Out "MOVQ R13, mm5"

INIT_MMX
Out "MOVQ mm3, R15"
Out "XOR R15, R15"
Out "XOR R15, R15"
Out "AND R15, R15"
Out "AND R15, R15"
Out "MOVQ R15, mm5"
Isolate_MMX
Out "MOVQ R15, mm5"

INIT_MMX
Out "MOVQ mm1, mm3"
Out "MOVQ mm7, mm1"
Out "MOVQ mm2, mm7"
Out "MOVQ mm6, mm2"
Out "MOVQ mm4, mm6"
Out "MOVQ mm5, mm4"
For I=0 To 15
  Out "MOVQ2DQ xmm"+Str(I)+", mm3"
  Out "PUNPCKLQDQ xmm"+Str(I)+", xmm"+Str(I)
Next
For I=0 To 15
  Out "MOVQ2DQ xmm"+Str(I)+", mm1"
  Out "PUNPCKLQDQ xmm"+Str(I)+", xmm"+Str(I)
Next
For I=0 To 15
  Out "MOVQ2DQ xmm"+Str(I)+", mm7"
  Out "PUNPCKLQDQ xmm"+Str(I)+", xmm"+Str(I)
Next
For I=0 To 15
  Out "MOVQ2DQ xmm"+Str(I)+", mm2"
  Out "PUNPCKLQDQ xmm"+Str(I)+", xmm"+Str(I)
Next
For I=0 To 15
  Out "MOVQ2DQ xmm"+Str(I)+", mm6"
  Out "PUNPCKLQDQ xmm"+Str(I)+", xmm"+Str(I)
Next
For I=0 To 15
  Out "MOVQ2DQ xmm"+Str(I)+", mm4"
  Out "PUNPCKLQDQ xmm"+Str(I)+", xmm"+Str(I)
Next
For I=0 To 15
  Out "MOVQ2DQ xmm"+Str(I)+", mm5"
  Out "PUNPCKLQDQ xmm"+Str(I)+", xmm"+Str(I)
Next

Out "EMMS"

Global fileno.i

fileno = CreateFile(#PB_Any, "WASAPI_Stabilizer_2_MMX.pbi")
If fileno
  WriteStringFormat(fileno, #PB_UTF8)
  WriteStringN(fileno, "; WASAPI_Stabilizer_2_MMX.pbi", #PB_UTF8)
  WriteStringN(fileno, "; Copyright (c) 2017-2019, Hiroyuki Yokota (oryaaaaa)", #PB_UTF8)
  For I=1 To 32
    WriteStringN(fileno, "!FNOP", #PB_UTF8)    
  Next
  ForEach SourceList()
    If Not Left(SourceList(), 1)=";"
      WriteStringN(fileno, "!"+SourceList(), #PB_UTF8)
    EndIf
  Next
  CloseFile(fileno)
EndIf

fileno = CreateFile(#PB_Any, "WASAPI_Stabilizer_2_MMX.txt")
If fileno
  WriteStringFormat(fileno, #PB_UTF8)
  WriteStringN(fileno, "; WASAPI_Stabilizer_2_MMX.txt", #PB_UTF8)
  WriteStringN(fileno, "; Copyright (c) 2017-2019, Hiroyuki Yokota (oryaaaaa)", #PB_UTF8)
  For I=1 To 32
    WriteStringN(fileno, "FNOP", #PB_UTF8)    
  Next
  ForEach SourceList()
    If Not Left(SourceList(), 1)=";"
      WriteStringN(fileno, SourceList(), #PB_UTF8)
    EndIf
  Next
  CloseFile(fileno)
EndIf

ForEach SourceList()
  FNOPx32
Next

fileno = CreateFile(#PB_Any, "WASAPI_Stabilizer_3_MMX.pbi")
If fileno
  WriteStringFormat(fileno, #PB_UTF8)
  WriteStringN(fileno, "; WASAPI_Stabilizer_3_MMX.pbi", #PB_UTF8)
  WriteStringN(fileno, "; Copyright (c) 2017-2019, Hiroyuki Yokota (oryaaaaa)", #PB_UTF8)
  For I=1 To 512
    WriteStringN(fileno, "!FNOP", #PB_UTF8)    
  Next
  ForEach SourceList()
    If Not Left(SourceList(), 1)=";"
      WriteStringN(fileno, "!"+SourceList(), #PB_UTF8)
    EndIf
  Next
  CloseFile(fileno)
EndIf

fileno = CreateFile(#PB_Any, "WASAPI_Stabilizer_3_MMX.txt")
If fileno
  WriteStringFormat(fileno, #PB_UTF8)
  WriteStringN(fileno, "; WASAPI_Stabilizer_3_MMX.txt", #PB_UTF8)
  WriteStringN(fileno, "; Copyright (c) 2017-2019, Hiroyuki Yokota (oryaaaaa)", #PB_UTF8)
  For I=1 To 512
    WriteStringN(fileno, "FNOP", #PB_UTF8)    
  Next
  ForEach SourceList()
    If Not Left(SourceList(), 1)=";"
      WriteStringN(fileno, SourceList(), #PB_UTF8)
    EndIf
  Next
  CloseFile(fileno)
EndIf

End
